# GFX Pipeline

The simplified graphics pipeline has 3 steps:
1. Vertex Generation
2. Primitive Processing
3. Rasterization


## Vertex Generation

Vertex generation consists of converting the coordinates from world space
into camera space.

To convert the coordinates to camera space, it multiplies them by the
inverse of the camera position in world space. After the multiplication
is done, it then normalizes the components by be between -1 and 1.
Following that, the normalized coordinates are converted into the final
pixel coordinates on screen by multiplying with the screen dimensions.

The transformed vertexes are stored into a buffer.

# Primitive Processing

For each triangle in the trangle array, the vertex indexes are looked up
in the transformed vertex buffer. The z coordinate is also inverted, which
is usefull during rasterization to compute the interpolated z coordinate.
The area of the triangle is also calculated. The texture points are looked up
in the texture buffer.

The transformed vertexes, area, texture coordinates, and texture index are
streamed to the rasterizer.

# Rasterizer

For each pixel in the output image, the rasterizer performs edge detection to
determine if the triangle is visible. If it is visible, it than interpolates
the z coordinate at the current pixel and checks the z buffer to see if
this pixel is occluded. If not, it updates the value in the z buffer.

If then interpolates the texture coordinate and looks up the texture value from
the texture buffer. The texture value is then written to the output buffer at
the current coordinate.

# Quick math

For every triangle, 6 memory accesses are required (24 bytes)
for every pixel, 4 memory accesses are required (16 bytes)

for 480p, 30fps, thats 9.2 million pixels per second, or 147MB/s

the fpga has a 32 bit data bus at 800MT/s, or a total of 3.2GB/s
of data throughput.

This should be good enough, since we only do the memory access
if the pixel is visible.

for rasterization, every pixel requires at least 3 edge functions, 
1 z interpolation, and 2 texture coord interpolation. That is 6+3+6=15
fp32 multiplies per pixel. There are also a handful of divides that we have
to do.