import fp32_pkg::*;

module fp32_vec4mat44mul_harness();

`include "fp32_helpers.svh"

`FP32_INPUT(v0);
`FP32_INPUT(v1);
`FP32_INPUT(v2);
`FP32_INPUT(v3);

`FP32_INPUT(a00);
`FP32_INPUT(a01);
`FP32_INPUT(a02);
`FP32_INPUT(a03);
`FP32_INPUT(a10);
`FP32_INPUT(a11);
`FP32_INPUT(a12);
`FP32_INPUT(a13);
`FP32_INPUT(a20);
`FP32_INPUT(a21);
`FP32_INPUT(a22);
`FP32_INPUT(a23);
`FP32_INPUT(a30);
`FP32_INPUT(a31);
`FP32_INPUT(a32);
`FP32_INPUT(a33);

`FP32_OUTPUT(y0);
`FP32_OUTPUT(y1);
`FP32_OUTPUT(y2);
`FP32_OUTPUT(y3);

logic i_valid, o_valid;

logic clk;

fp32_vec4mat44mul u_dut(
    .clk        (clk),
    .i_valid    (i_valid),
    .v          ({v0, v1, v2, v3}),
    .a        ({{a00, a01, a02, a03},
                {a10, a11, a12, a13},
                {a20, a21, a22, a23},
                {a30, a31, a32, a33}
                }),
    .y          ({y0, y1, y2, y3}),

    .o_valid    (o_valid)
);

endmodule