import fp32_pkg::*;

module fp32_gt (
    input clk,

    input i_valid,
    
    input fp32_t a,
    input fp32_t b,

    output logic gt,

    output logic o_valid
);

// outputs 1 if a > b

logic gt_next;

always_ff @(posedge clk) begin
    o_valid <= i_valid;
    gt <= gt_next;
end

always_comb begin
    if (a.sign == b.sign) begin
        if (a.exponent < b.exponent) begin
            gt_next = a.sign;   // if both negative, then if a.exp < b.exp a > b.
        end else if (a.exponent == b.exponent && a.mantissa < b.mantissa) begin
            gt_next = a.sign;
        end else begin
            gt_next = ~a.sign;
        end
    end else begin
        gt_next = (a.sign < b.sign) ? 1 : 0;
    end
end

endmodule