import fp32_pkg::*;

module fp32_vec4mat44mul(
    input clk,

    input i_valid,

    input fp32_t v[4],
    input fp32_t a[4][4],

    output fp32_t y[4],

    output o_valid
);

fp32_t mat_result[4][4];
logic mat_valid[4][4];

fp32_t sum1[2][4];
logic sum1_valid[2][4];

logic [3:0] sum2_valid;

assign o_valid = &sum2_valid;

genvar i, j;

generate
    for (i = 0; i < 4; i++) begin       : matmul_outer_loop
        for (j = 0; j < 4; j++) begin   : matmul_inner_loop
            fp32_mul u_mul (
                .clk    (clk),
                .i_valid(i_valid),
                .a      (a[i][j]),
                .b      (v[i]),
                .z      (mat_result[i][j]),
                .o_valid(mat_valid[i][j])
            );
        end

        fp32_add u_add0 (
            .clk    (clk),
            .i_valid(mat_valid[0][i] & mat_valid[1][i]),  // dubious
            .a      (mat_result[0][i]),
            .b      (mat_result[1][i]),
            .z      (sum1[0][i]),
            .o_valid(sum1_valid[0][i])
        );

        fp32_add u_add1 (
            .clk    (clk),
            .i_valid(mat_valid[2][i] & mat_valid[3][i]),  // dubious
            .a      (mat_result[2][i]),
            .b      (mat_result[3][i]),
            .z      (sum1[1][i]),
            .o_valid(sum1_valid[1][i])
        );

        fp32_add u_add2 (
            .clk    (clk),
            .i_valid(sum1_valid[0][i] & sum1_valid[1][i]),  // dubious
            .a      (sum1[0][i]),
            .b      (sum1[1][i]),
            .z      (y[i]),
            .o_valid(sum2_valid[i])
        );
    end
endgenerate



endmodule