module vertex_generator_control_harness();

import fp32_pkg::*;

`include "fp32_helpers.svh"

logic clk;
logic rst;

fp32_t world_to_camera_matrix[4][4];
fp32_t projection_matrix[4][4];
fp32_t screen_dim[2];

logic [31:0] vertex_buffer_source;
logic [31:0] vertex_buffer_dest;
logic [31:0] vertex_buffer_len;

logic start;
logic done;

`FP32_OUTPUT(world_to_camera_matrix00);
`FP32_OUTPUT(world_to_camera_matrix01);
`FP32_OUTPUT(world_to_camera_matrix02);
`FP32_OUTPUT(world_to_camera_matrix03);
`FP32_OUTPUT(world_to_camera_matrix10);
`FP32_OUTPUT(world_to_camera_matrix11);
`FP32_OUTPUT(world_to_camera_matrix12);
`FP32_OUTPUT(world_to_camera_matrix13);
`FP32_OUTPUT(world_to_camera_matrix20);
`FP32_OUTPUT(world_to_camera_matrix21);
`FP32_OUTPUT(world_to_camera_matrix22);
`FP32_OUTPUT(world_to_camera_matrix23);
`FP32_OUTPUT(world_to_camera_matrix30);
`FP32_OUTPUT(world_to_camera_matrix31);
`FP32_OUTPUT(world_to_camera_matrix32);
`FP32_OUTPUT(world_to_camera_matrix33);

`FP32_OUTPUT(projection_matrix00);
`FP32_OUTPUT(projection_matrix01);
`FP32_OUTPUT(projection_matrix02);
`FP32_OUTPUT(projection_matrix03);
`FP32_OUTPUT(projection_matrix10);
`FP32_OUTPUT(projection_matrix11);
`FP32_OUTPUT(projection_matrix12);
`FP32_OUTPUT(projection_matrix13);
`FP32_OUTPUT(projection_matrix20);
`FP32_OUTPUT(projection_matrix21);
`FP32_OUTPUT(projection_matrix22);
`FP32_OUTPUT(projection_matrix23);
`FP32_OUTPUT(projection_matrix30);
`FP32_OUTPUT(projection_matrix31);
`FP32_OUTPUT(projection_matrix32);
`FP32_OUTPUT(projection_matrix33);

`FP32_OUTPUT(screen_x);
`FP32_OUTPUT(screen_y);

assign world_to_camera_matrix00 = world_to_camera_matrix[0][0];
assign world_to_camera_matrix01 = world_to_camera_matrix[0][1];
assign world_to_camera_matrix02 = world_to_camera_matrix[0][2];
assign world_to_camera_matrix03 = world_to_camera_matrix[0][3];
assign world_to_camera_matrix10 = world_to_camera_matrix[1][0];
assign world_to_camera_matrix11 = world_to_camera_matrix[1][1];
assign world_to_camera_matrix12 = world_to_camera_matrix[1][2];
assign world_to_camera_matrix13 = world_to_camera_matrix[1][3];
assign world_to_camera_matrix20 = world_to_camera_matrix[2][0];
assign world_to_camera_matrix21 = world_to_camera_matrix[2][1];
assign world_to_camera_matrix22 = world_to_camera_matrix[2][2];
assign world_to_camera_matrix23 = world_to_camera_matrix[2][3];
assign world_to_camera_matrix30 = world_to_camera_matrix[3][0];
assign world_to_camera_matrix31 = world_to_camera_matrix[3][1];
assign world_to_camera_matrix32 = world_to_camera_matrix[3][2];
assign world_to_camera_matrix33 = world_to_camera_matrix[3][3];

assign projection_matrix00 = projection_matrix[0][0];
assign projection_matrix01 = projection_matrix[0][1];
assign projection_matrix02 = projection_matrix[0][2];
assign projection_matrix03 = projection_matrix[0][3];
assign projection_matrix10 = projection_matrix[1][0];
assign projection_matrix11 = projection_matrix[1][1];
assign projection_matrix12 = projection_matrix[1][2];
assign projection_matrix13 = projection_matrix[1][3];
assign projection_matrix20 = projection_matrix[2][0];
assign projection_matrix21 = projection_matrix[2][1];
assign projection_matrix22 = projection_matrix[2][2];
assign projection_matrix23 = projection_matrix[2][3];
assign projection_matrix30 = projection_matrix[3][0];
assign projection_matrix31 = projection_matrix[3][1];
assign projection_matrix32 = projection_matrix[3][2];
assign projection_matrix33 = projection_matrix[3][3];

assign screen_x = screen_dim[0];
assign screen_y = screen_dim[1];


axil_intf #(.AXIL_DATA_WIDTH(32), .AXIL_ADDR_WIDTH(32)) m_ctrl_axil();
axil_intf #(.AXIL_DATA_WIDTH(32), .AXIL_ADDR_WIDTH(32)) s_ctrl_axil();

vertex_generator_control u_dut (
    .clk                    (clk),
    .rst                    (rst),

    .m_ctrl_axil            (m_ctrl_axil),
    .s_ctrl_axil            (s_ctrl_axil),

    .world_to_camera_matrix (world_to_camera_matrix),
    .projection_matrix      (projection_matrix),
    .screen_dim             (screen_dim),

    .vertex_buffer_source   (vertex_buffer_source),
    .vertex_buffer_dest     (vertex_buffer_dest),
    .vertex_buffer_len      (vertex_buffer_len),

    .start                  (start),
    .done                   (done)
);

endmodule