import fp32_pkg::*;

module vertex_generator_normalization_harness();

`include "fp32_helpers.svh"

`FP32_INPUT(v0);
`FP32_INPUT(v1);
`FP32_INPUT(v2);
`FP32_INPUT(v3);
`FP32_OUTPUT(y0);
`FP32_OUTPUT(y1);
`FP32_OUTPUT(y2);

logic i_valid, o_valid;
logic o_visible;

logic clk;

vertex_generator_normalization u_dut(
    .clk        (clk),
    .i_valid    (i_valid),
    .v          ({v0, v1, v2, v3}),
    .y          ({y0, y1, y2}),
    .o_visible  (o_visible),
    .o_valid    (o_valid)
);

endmodule