module vertex_generator_read_fsm_harness();

logic clk;
logic rst;

axil_intf #(.AXIL_DATA_WIDTH(128), .AXIL_ADDR_WIDTH(32)) m_axil_read();

logic [31:0] source_addr;
logic [31:0] len;
logic start;
logic done;

logic valid;
logic ready;

`FP32_OUTPUT(vertex0);
`FP32_OUTPUT(vertex1);
`FP32_OUTPUT(vertex2);

vertex_generator_read_fsm u_dut(
    .clk            (clk),
    .rst            (rst),

    .source_addr    (source_addr),
    .len            (len),
    .start          (start),
    .done           (done),

    .valid          (valid),
    .ready          (ready),
    .vertex         ({vertex0, vertex1, vertex2}),

    .m_axil_read    (m_axil_read)
);

endmodule