module vertex_generator_write_fsm_harness();

logic clk;
logic rst;

axil_intf #(.AXIL_DATA_WIDTH(128), .AXIL_ADDR_WIDTH(32)) m_axil_write();

logic [31:0] dest_addr;
logic [31:0] len;
logic start;
logic done;

logic valid;
logic ready;

logic visible;

`FP32_INPUT(vertex0);
`FP32_INPUT(vertex1);
`FP32_INPUT(vertex2);

vertex_generator_write_fsm u_dut(
    .clk            (clk),
    .rst            (rst),

    .dest_addr      (dest_addr),
    .len            (len),
    .start          (start),
    .done           (done),

    .valid          (valid),
    .ready          (ready),
    .visible        (visible),
    .vertex         ({vertex0, vertex1, vertex2}),

    .m_axil_write   (m_axil_write)
);

endmodule